﻿Imports ConfigurationUtility
Public Class ACCurrentCalibration
    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public UsingAPI As Boolean = True ' flag for if using API mode
    Public ACChannels As Byte
    Public DeviceAddress As Decimal


    Private Sub ACCurrentCalibration_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        LoadCalibrationDataFromController()
    End Sub

    Private Sub ReadButton_Click(sender As Object, e As EventArgs) Handles ReadButton.Click
        LoadCalibrationDataFromController()
    End Sub

    Private Sub WriteButton_Click(sender As Object, e As EventArgs) Handles WriteButton.Click

        Me.Enabled = False
        Dim MSB_1 As Byte = NCDLib.Math.GetMSB(CAL1.Value)
        Dim LSB_1 As Byte = NCDLib.Math.GetLSB(CAL1.Value)
        Dim CKSUM_1 As Byte = (MSB_1 + LSB_1 + 2) And 255

        Dim MSB_2 As Byte = NCDLib.Math.GetMSB(CAL2.Value)
        Dim LSB_2 As Byte = NCDLib.Math.GetLSB(CAL2.Value)
        Dim CKSUM_2 As Byte = (MSB_2 + LSB_2 + 4) And 255

        Dim MSB_3 As Byte = NCDLib.Math.GetMSB(CAL3.Value)
        Dim LSB_3 As Byte = NCDLib.Math.GetLSB(CAL3.Value)
        Dim CKSUM_3 As Byte = (MSB_3 + LSB_3 + 6) And 255

        Dim MSB_4 As Byte = NCDLib.Math.GetMSB(CAL4.Value)
        Dim LSB_4 As Byte = NCDLib.Math.GetLSB(CAL4.Value)
        Dim CKSUM_4 As Byte = (MSB_4 + LSB_4 + 8) And 255

        Dim MSB_5 As Byte = NCDLib.Math.GetMSB(CAL5.Value)
        Dim LSB_5 As Byte = NCDLib.Math.GetLSB(CAL5.Value)
        Dim CKSUM_5 As Byte = (MSB_5 + LSB_5 + 10) And 255

        Dim MSB_6 As Byte = NCDLib.Math.GetMSB(CAL6.Value)
        Dim LSB_6 As Byte = NCDLib.Math.GetLSB(CAL6.Value)
        Dim CKSUM_6 As Byte = (MSB_6 + LSB_6 + 12) And 255

        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 188, 50, 9, DeviceAddress, 146, 106, 4, 1, 1, MSB_1, LSB_1, CKSUM_1, 0) : Confirm(1)
        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 188, 50, 9, DeviceAddress, 146, 106, 4, 2, 2, MSB_2, LSB_2, CKSUM_2, 0) : Confirm(2)
        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 188, 50, 9, DeviceAddress, 146, 106, 4, 3, 3, MSB_3, LSB_3, CKSUM_3, 0) : Confirm(3)
        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 188, 50, 9, DeviceAddress, 146, 106, 4, 4, 4, MSB_4, LSB_4, CKSUM_4, 0) : Confirm(4)
        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 188, 50, 9, DeviceAddress, 146, 106, 4, 5, 5, MSB_5, LSB_5, CKSUM_5, 0) : Confirm(5)
        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 188, 50, 9, DeviceAddress, 146, 106, 4, 6, 6, MSB_6, LSB_6, CKSUM_6, 0) : Confirm(6)

        Me.Enabled = True

    End Sub
    Public Sub Confirm(Channel As Integer)
        Dim ConfirmByte As Integer = NCDLib.ReadByteAPI(NCDComponent1, UsingAPI)
        Debug.Print(Channel.ToString + ":" + ConfirmByte.ToString)
    End Sub
    Public Sub LoadCalibrationDataFromController()

        'ACChannels = ACCurrentMonitoring.ACChannels
        Debug.Print(ACChannels)

        Debug.Print("Channels:" + ACChannels.ToString)
        Dim ACChannelBytes = (ACChannels * 2) + 1

        NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 188, 50, 10, DeviceAddress, 146, 106, 3, 1, ACChannels, 0, 0, ACChannels, (DeviceAddress + 1), ACChannelBytes)
        Dim PacketLength As Integer = ACChannelBytes ' ((ACCurrentMonitoring.Channels * 2) + 1)
        'NCDLib.WriteBytesAPI(NCDComponent1, UsingAPI, 188, 50, 1, 85, PacketLength)
        Dim CalibrationValues As Byte() = NCDLib.ReadBytesAPI(NCDComponent1, UsingAPI, PacketLength)
        If CalibrationValues IsNot Nothing Then

            Dim CkSum As Integer = CalibrationValues((ACChannels * 2))
            Dim CalcSum As Integer = 0

            For X As Integer = 0 To ((ACChannels * 2) - 1)
                CalcSum = CalcSum + CalibrationValues(X)
            Next X


            If (CalcSum And 255) <> CkSum Then
                Debug.Print("Checksum Calculation Error: " + CalcSum.ToString + ":" + CkSum.ToString)
            Else
                Debug.Print("1:" + ((CalibrationValues(0) * 256) + CalibrationValues(1)).ToString())  'Channel 1 Display
                CAL1.Value = NCDLib.Safe.Limit_16BIT((CalibrationValues(0) * 256) + CalibrationValues(1))
                If ACChannels > 1 Then
                    Debug.Print("2:" + ((CalibrationValues(2) * 256) + CalibrationValues(3)).ToString())  'Channel 2 Display
                    CAL2.Value = NCDLib.Safe.Limit_16BIT((CalibrationValues(2) * 256) + CalibrationValues(3))
                End If
                If ACChannels > 2 Then
                    Debug.Print("3:" + ((CalibrationValues(4) * 256) + CalibrationValues(5)).ToString())  'Channel 3 Display
                    CAL3.Value = NCDLib.Safe.Limit_16BIT((CalibrationValues(4) * 256) + CalibrationValues(5))
                End If
                If ACChannels > 3 Then
                    Debug.Print("4:" + ((CalibrationValues(6) * 256) + CalibrationValues(7)).ToString())  'Channel 4 Display
                    CAL4.Value = NCDLib.Safe.Limit_16BIT((CalibrationValues(6) * 256) + CalibrationValues(7))
                End If
                If ACChannels > 4 Then
                    Debug.Print("5:" + ((CalibrationValues(8) * 256) + CalibrationValues(9)).ToString())  'Channel 5 Display
                    CAL5.Value = NCDLib.Safe.Limit_16BIT((CalibrationValues(8) * 256) + CalibrationValues(9))
                End If
                If ACChannels > 5 Then
                    Debug.Print("6:" + ((CalibrationValues(10) * 256) + CalibrationValues(11)).ToString()) 'Channel 6 Display
                    CAL6.Value = NCDLib.Safe.Limit_16BIT((CalibrationValues(10) * 256) + CalibrationValues(11))
                End If
            End If
        End If

    End Sub

    Private Sub NumericUpDown1_ValueChanged(sender As Object, e As EventArgs) Handles MeterReading.ValueChanged
        CalculateNewCalibrationValue()
    End Sub
    Private Sub NumericUpDown2_ValueChanged(sender As Object, e As EventArgs) Handles ErrantCalibrationValue.ValueChanged
        CalculateNewCalibrationValue()
    End Sub
    Private Sub NumericUpDown3_ValueChanged(sender As Object, e As EventArgs) Handles SensorReading.ValueChanged
        CalculateNewCalibrationValue()
    End Sub

    Public Sub CalculateNewCalibrationValue()
        Try
            Result.Text = Int((MeterReading.Value / SensorReading.Value) * ErrantCalibrationValue.Value)
        Catch
        End Try
    End Sub


End Class