﻿Public Class frmPR53_25
    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public ScaleSetting As Integer = 0
    Public FormLoading As Boolean = True
    Private Sub frmPR53_25_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'MCP4728 & ADS1115
        Dim I(15) As Byte
        I = NCDLib.Enterprise.Setup.EEPROM_Read(NCDComponent1, True, 7600, 16)
        If I IsNot Nothing Then
            DAC1.Value = NCDLib.Safe.Limit_Value(NCDLib.Math.MSBLSB(I(0), I(1)), 0, 4095)
            DAC2.Value = NCDLib.Safe.Limit_Value(NCDLib.Math.MSBLSB(I(2), I(3)), 0, 4095)
            RAW3.Text = DAC1.Value.ToString
            Dim Value As Decimal = (DAC1.Value * (10.3992 / 4095))
            Real3.Text = String.Format("{0:0.000}", Value) + "V"
            RAW4.Text = DAC2.Value.ToString
            Value = (DAC2.Value * (10.3992 / 4095))
            Real4.Text = String.Format("{0:0.000}", Value) + "V"
            'Recovery Statup-State Options Drop Selection
            If ((I(8) And 128) = 0) And ((I(8) And 64) = 0) Then Recovery.SelectedIndex = 0
            If ((I(8) And 128) = 0) And ((I(8) And 64) = 64) Then Recovery.SelectedIndex = 1
            If ((I(8) And 128) = 128) And ((I(8) And 64) = 0) Then Recovery.SelectedIndex = 2
        End If
        FormLoading = False
    End Sub
    Public Sub RefreshUI()
        Dim InputReadings As Byte() = NCDLib.Enterprise.Device.PR53_25.ReadInputs(NCDComponent1, 1, 2, ScaleSetting)
        If InputReadings IsNot Nothing Then
            RAW1.Text = NCDLib.Enterprise.Device.PR53_25.RawValue(InputReadings(0), InputReadings(1))
            RAW2.Text = NCDLib.Enterprise.Device.PR53_25.RawValue(InputReadings(2), InputReadings(3))
            Real1.Text = NCDLib.Enterprise.Device.PR53_25.RealValue(InputReadings(0), InputReadings(1), ScaleSetting)
            Real2.Text = NCDLib.Enterprise.Device.PR53_25.RealValue(InputReadings(2), InputReadings(3), ScaleSetting)
            Channel1.Value = NCDLib.Enterprise.Device.PR53_25.RawValueDec(InputReadings(0), InputReadings(1))
            Channel2.Value = NCDLib.Enterprise.Device.PR53_25.RawValueDec(InputReadings(2), InputReadings(3))
        End If
        GetTXRXData()
    End Sub
    Private Sub ScaleSelection_CheckedChanged(sender As Object, e As EventArgs) Handles ScaleSelection.CheckedChanged
        If ScaleSelection.Checked = True Then
            ScaleSetting = 1
            Channel1.Maximum = 65535
            Channel2.Maximum = 65535
        Else
            ScaleSetting = 0
            Channel1.Maximum = 16383
            Channel2.Maximum = 16383
        End If
    End Sub
    Private Sub ReadAll_Click(sender As Object, e As EventArgs) Handles ReadAll.Click
        RefreshUI()
        GetTXRXData()
    End Sub
    Private Sub DAC1_Scroll(sender As Object, e As ScrollEventArgs) Handles DAC1.Scroll
        RAW3.Text = DAC1.Value.ToString
        Dim Value As Decimal = (DAC1.Value * (10.3992 / 4095))
        Real3.Text = String.Format("{0:0.000}", Value) + "V"
        NCDLib.Enterprise.Device.PR53_25.SetOutputs(NCDComponent1, 1, 1, DAC1.Value)
        GetTXRXData()
    End Sub
    Private Sub DAC2_Scroll(sender As Object, e As ScrollEventArgs) Handles DAC2.Scroll
        RAW4.Text = DAC2.Value.ToString
        Dim Value As Decimal = (DAC2.Value * (10.3992 / 4095))
        Real4.Text = String.Format("{0:0.000}", Value) + "V"
        NCDLib.Enterprise.Device.PR53_25.SetOutputs(NCDComponent1, 2, 2, DAC2.Value)
        GetTXRXData()
    End Sub
    Public Sub GetTXRXData()
        txtTransmitString.Text = NCDLib.GetLastTransmitString
        txtRecString.Text = NCDLib.GetLastReceivingString
        Me.Refresh()
    End Sub
    Private Sub Recovery_SelectedIndexChanged(sender As Object, e As EventArgs) Handles Recovery.SelectedIndexChanged
        If FormLoading = True Then Exit Sub
        NCDLib.Enterprise.Device.PR53_25.StorePowerUpDefaultOptions(NCDComponent1, Recovery.SelectedIndex)
        GetTXRXData()
    End Sub
    Private Sub StorePowerupDefaultState_Click(sender As Object, e As EventArgs) Handles StorePowerupDefaultState.Click
        Recovery.SelectedIndex = 2
        If FormLoading = True Then Exit Sub
        NCDLib.Enterprise.Device.PR53_25.StorePowerUpDefaultState(NCDComponent1, DAC1.Value, DAC2.Value)
        GetTXRXData()
    End Sub
End Class