﻿Imports System.IO
Public Class frmSubscriberRelay
    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public FormLoading As Boolean = True
    Private Sub frmSubscriberRelay_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' Dim DataBlock(32, 32) As Byte
        'Dim Preload = New Byte() {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16}
        Dim DataBlock(63, 15) As Byte   ' {{Preload}, {Preload}}
        For Line As Integer = 0 To 63
            For Column As Integer = 0 To 15
                Dim Value As Integer = (Line * 16) + Column
                DataBlock(Line, Column) = (Value And 255)
                Debug.Print(Value.ToString + "-" + DataBlock(Line, Column).ToString)
            Next
        Next

    End Sub
    Public Sub PutSubscriberCell(x As Integer, Y As Integer, Dat As String)
        SubscriberTable(x, Y).Value = Dat
    End Sub
    Public Function GetSubscriberCell(x As Integer, Y As Integer) As String
        GetSubscriberCell = SubscriberTable(x, Y).Value
    End Function
    Public Sub PutByteTableCell(x As Integer, Y As Integer, Dat As String)
        ByteTable(x, Y).Value = Dat
    End Sub
    Public Function GetByteTableCell(x As Integer, Y As Integer) As String
        GetByteTableCell = ByteTable(x, Y).Value
    End Function

    Private Sub Upload_Click(sender As Object, e As EventArgs) Handles Upload.Click

    End Sub

    Private Sub Download_Click(sender As Object, e As EventArgs) Handles Download.Click

    End Sub

    Private Sub LoadDataFile_Click(sender As Object, e As EventArgs) Handles LoadDataFile.Click
        Dim OpenFileDialog1 As OpenFileDialog = New OpenFileDialog
        OpenFileDialog1.FileName = "SubscriberData.cfg"
        Dim data As Byte() = Nothing
        If (OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            '         data = LoadFile(OpenFileDialog1.FileName)
            FileProgress.Value = 0
            FileProgress.Visible = True
            Dim Block As Integer
            Dim I(15) As Byte
            Dim saveData As New ArrayList
            Dim id As Integer = 0
            For Block = 1040 To 6800 Step 16
                Array.Copy(data, id, I, 0, 16)
                id = id + 16
                NCDLib.Enterprise.Setup.EEPROM_Write(NCDComponent1, True, Block, I)
                Debug.Print(Block.ToString)
                FileProgress.Value = Block
            Next Block

            FileProgress.Visible = False
        End If
    End Sub
    Private Sub SaveDataFile_Click(sender As Object, e As EventArgs) Handles SaveDataFile.Click
        FileProgress.Value = 0
        FileProgress.Visible = True

        'Start Address of Data: 1040
        'Ending Address of Data: 6800

        Dim Block As Integer
        Dim I(15) As Byte
        Dim saveData As New ArrayList

        For Block = 1040 To 6800 Step 16
            I = NCDLib.Enterprise.Setup.EEPROM_Read(NCDComponent1, True, Block, 16)
            saveData.AddRange(I)
            Debug.Print(Block.ToString)
            FileProgress.Value = Block
        Next Block

        Dim result As Boolean = False
        Dim SaveFileDialog1 As SaveFileDialog = New SaveFileDialog
        SaveFileDialog1.FileName = "SubscriberData.cfg"
        Dim d As Byte = 0
        If (SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            SaveFile(SaveFileDialog1.FileName, saveData.ToArray(d.GetType()))
        End If

        FileProgress.Visible = False
    End Sub
    '' <summary>
    '' Load file from specific path
    '' </summary>
    '' <param name="filename"></param>
    '' <returns>bytes read from file</returns>
    '' <remarks></remarks>
    '' <exception cref="Exception">Corrupt NCD File</exception>
    Public Function LoadFile(ByVal filename As String) As Byte()
        Dim data As Byte() = Nothing
        Try
            Dim sr As BinaryReader = New BinaryReader(File.Open(filename, FileMode.Open))
            Dim version As Integer = sr.ReadInt32()
            Dim length As Integer = sr.ReadInt32()
            data = sr.ReadBytes(length)
            Dim checksum As Integer = sr.ReadInt32()
            If (checksum <> GetCheckSum(data)) Then
                Throw New Exception("Corrupt Data File")
            End If
            sr.Close()
        Catch ex As Exception
            Throw New Exception("Corrupt Data File")
        End Try
        Return data
    End Function

    ''' <summary>
    ''' Save file to specific path
    ''' </summary>
    ''' <param name="filename"></param>
    ''' <param name="data"></param>
    ''' <remarks></remarks>
    Public Sub SaveFile(ByVal filename As String, ByVal data As Byte())
        Try
            Dim sw As BinaryWriter = New BinaryWriter(File.Open(filename, FileMode.Create))
            Dim version As Integer = 1
            Dim length As Integer = data.Length
            Dim i As Integer = 0
            sw.Write(version)
            sw.Write(length)
            sw.Write(data, 0, length)
            Dim chksum As Integer = GetCheckSum(data)
            sw.Write(chksum)
            sw.Flush()
            sw.Close()
        Catch ex As Exception
            Throw New Exception("Write keyfob file failure")
        End Try
    End Sub
    Private Function GetCheckSum(ByVal a As Byte()) As Integer
        Dim i As Integer = 0
        Dim checksum As Integer = 0
        For i = 0 To a.Length - 1
            checksum = checksum + a(i)
        Next
        Return checksum
    End Function


End Class